from __future__ import with_statement
print "b29"
os.chdir("/Users/was/talks/2007-01-15-sage-cse/sage_notebook/worksheets/sieve/cells/114")
__SAGE_t__=cputime()
__SAGE_w__=walltime()
all
#auto

def sieve_step(p, n, gone=(Integer(1),Integer(1),Integer(1)), prime=(Integer(1),Integer(0),Integer(0)), \
               multiple=(RealNumber('.6'),RealNumber('.6'),RealNumber('.6')), remaining=(RealNumber('.9'),RealNumber('.9'),RealNumber('.9')),
               fontsize=Integer(11),offset=Integer(0)):
    """
    Return graphics that illustrates sieving out
    multiples of p.   Numbers that are a nontrivial
    multiple of primes < p are shown in the gone color.
    Numbers that are a multiple of p are shown in
    a different color.  The number p is shown in
    yet a third color.

    INPUT:
        p -- a prime (or 1, in which case all points are colored "remaining")
        n -- a SQUARE integer
        gone -- rgb color for integers that have been sieved out
        prime -- rgb color for p
        multiple -- rgb color for multiples of p
        remaining -- rgb color for integers that have not been sieved out yet
                     and are not multiples of p.
    """
    if p == Integer(1):
        c = [remaining]*n
    else:
        exclude = prod(prime_range(p))  # exclude multiples of primes < p
        c = []
        for k in range(Integer(1),n+Integer(1)):
            if k <= p and is_prime(k):
                c.append(prime)
            elif k == Integer(1) or (gcd(k,exclude) != Integer(1) and not is_prime(k)):
                c.append(gone)
            elif k%p == Integer(0):
                c.append(multiple)
            else:
                c.append(remaining)
        # end for
    # end if
    return number_grid(c,{},{'fontsize':fontsize},offset=offset)
print "CPU time: %.2f s,  Wall time: %.2f s"%(cputime(__SAGE_t__), walltime(__SAGE_w__))
print "\n\nv=%s"%_support_.variables(True)
print "e29"
